/* --------------------------------------------------------- */
/*	test													 */
/* ========================================================= */
/*	(C)2004 t.hara											 */
/* --------------------------------------------------------- */

#define	LCD_DATA	0xFFFFD3

#define	POKE8( Adr, Data )	( *(volatile unsigned char*)(Adr) = (Data) )

/* --------------------------------------------------------- */
void WaitLcd( void ) {
	volatile int i;

	for( i = 0; i < 170; i++ );
}

/* --------------------------------------------------------- */
void LcdPutc( char c ) {

	POKE8( LCD_DATA, ((c >> 4) & 0x0F) | 0x30 );
	WaitLcd();
	POKE8( LCD_DATA, ((c >> 4) & 0x0F) | 0x10 );
	WaitLcd();
	POKE8( LCD_DATA, (c & 0x0F) | 0x30 );
	WaitLcd();
	POKE8( LCD_DATA, (c & 0x0F) | 0x10 );
	WaitLcd();
}

/* --------------------------------------------------------- */
void LcdCommand( char c ) {

	POKE8( LCD_DATA, ((c >> 4) & 0x0F) | 0x20 );
	WaitLcd();
	POKE8( LCD_DATA, ((c >> 4) & 0x0F) | 0x00 );
	WaitLcd();
	POKE8( LCD_DATA, (c & 0x0F) | 0x20 );
	WaitLcd();
	POKE8( LCD_DATA, (c & 0x0F) | 0x00 );
	WaitLcd();
}

/* --------------------------------------------------------- */
void LcdPuts( const char *pStr ) {

	while( *pStr ) {
		LcdPutc( *pStr );
		++pStr;
	}
}

/* --------------------------------------------------------- */
void main( void ) {

	LcdCommand( 0x00 | 0x80 );
	LcdPuts( "Hello, World!" );
	LcdCommand( 0x40 | 0x80 );
	LcdPuts( "Test Program" );
	LcdCommand( 0x14 | 0x80 );
	LcdPuts( "  =(^^)=" );
	LcdCommand( 0x54 | 0x80 );
	LcdPuts( "   (..)/" );
	while( 1 );
}
